

package ibspan.tss.oms.ontology;

import com.hp.hpl.jena.rdf.model.*;

/**
 * Interface for ExtInfo ontology class<br>
 * Use the ibspan.tss.oms.ontology.OMSFactory to create instances of this interface.
 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#ExtInfo)</p>
 * <br>
 * <br>
 * <br>
 */
public interface ExtInfo extends com.ibm.adtech.jastor.Thing {
	
	/**
	 * The rdf:type for this ontology class
     */
	public static final Resource TYPE = ResourceFactory.createResource("http://www.ibspan.waw.pl/tss/OMS#ExtInfo");
	

	/**
	 * The Jena Property for hasPositiveOntSrc 
	 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#hasPositiveOntSrc)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property hasPositiveOntSrcProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasPositiveOntSrc");


	/**
	 * The Jena Property for hasMainOntSrc 
	 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#hasMainOntSrc)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property hasMainOntSrcProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasMainOntSrc");


	/**
	 * The Jena Property for hasUpdateDateTime 
	 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#hasUpdateDateTime)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property hasUpdateDateTimeProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasUpdateDateTime");


	/**
	 * The Jena Property for hasNegativeOntSrc 
	 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#hasNegativeOntSrc)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property hasNegativeOntSrcProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasNegativeOntSrc");


	/**
	 * The Jena Property for hasIncompleteCheckDateTime 
	 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#hasIncompleteCheckDateTime)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property hasIncompleteCheckDateTimeProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasIncompleteCheckDateTime");


	/**
	 * The Jena Property for hasCF 
	 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#hasCF)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property hasCFProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasCF");






	/**
	 * Get an Iterator the 'hasPositiveOntSrc' property values.  This Iteartor
	 * may be used to remove all such values.
	 * @return		{@link java.util.Iterator} of {@link ibspan.tss.oms.ontology.OntologySource}
	 * @see			#hasPositiveOntSrcProperty
	 */
	public java.util.Iterator getHasPositiveOntSrc() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Adds a value for the 'hasPositiveOntSrc' property
	 * @param		The {@link ibspan.tss.oms.ontology.OntologySource} to add
	 * @see			#hasPositiveOntSrcProperty
	 */
	public void addHasPositiveOntSrc(ibspan.tss.oms.ontology.OntologySource hasPositiveOntSrc) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Adds an anonymous value for the 'hasPositiveOntSrc' property
	 * @return		The anoymous {@link ibspan.tss.oms.ontology.OntologySource} created
	 * @see			#hasPositiveOntSrcProperty
	 */
	public ibspan.tss.oms.ontology.OntologySource addHasPositiveOntSrc() throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Adds a value for the 'hasPositiveOntSrc' property.  This
	 * method is equivalent constructing a new instance of {@link ibspan.tss.oms.ontology.OntologySource} with the factory
	 * and calling addHasPositiveOntSrc(ibspan.tss.oms.ontology.OntologySource hasPositiveOntSrc)
	 * The resource argument have rdf:type http://www.ibspan.waw.pl/tss/OMS#OntologySource.  That is, this method
	 * should not be used as a shortcut for creating new objects in the model.
	 * @param		The {@link om.hp.hpl.jena.rdf.model.Resource} to add
	 * @see			#hasPositiveOntSrcProperty
	 */
	public ibspan.tss.oms.ontology.OntologySource addHasPositiveOntSrc(com.hp.hpl.jena.rdf.model.Resource resource) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Removes a value for the 'hasPositiveOntSrc' property.  This method should not
	 * be invoked while iterator through values.  In that case, the remove() method of the Iterator
	 * itself should be used.
	 * @param		The {@link ibspan.tss.oms.ontology.OntologySource} to remove
	 * @see			#hasPositiveOntSrcProperty
	 */
	public void removeHasPositiveOntSrc(ibspan.tss.oms.ontology.OntologySource hasPositiveOntSrc) throws com.ibm.adtech.jastor.JastorException;
		
	/**
	 * Gets the 'hasMainOntSrc' property value
	 * @return		{@link ibspan.tss.oms.ontology.OntologySource}
	 * @see			#hasMainOntSrcProperty
	 */
	public ibspan.tss.oms.ontology.OntologySource getHasMainOntSrc() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'hasMainOntSrc' property value
	 * @param		{@link ibspan.tss.oms.ontology.OntologySource}
	 * @see			#hasMainOntSrcProperty
	 */
	public void setHasMainOntSrc(ibspan.tss.oms.ontology.OntologySource hasMainOntSrc) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Sets the 'hasMainOntSrc' property value to an anonymous node
	 * @return		{@link ibspan.tss.oms.ontology.OntologySource}, the created value
	 * @see			#hasMainOntSrcProperty
	 */	
	public ibspan.tss.oms.ontology.OntologySource setHasMainOntSrc() throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Sets the 'hasMainOntSrc' property value to the given resource, and add's rdf:type properties.  This
	 * method is equivalent constructing a new instance of {@link ibspan.tss.oms.ontology.OntologySource} with the factory.
	 * and calling setHasMainOntSrc(ibspan.tss.oms.ontology.OntologySource hasMainOntSrc)
	 * The resource argument have rdf:type http://www.ibspan.waw.pl/tss/OMS#OntologySource.  That is, this method
	 * should not be used as a shortcut for creating new objects in the model.
	 * @param		{@link com.hp.hpl.jena.rdf.model.Resource} must not be be null.
	 * @return		{@link ibspan.tss.oms.ontology.OntologySource}, the newly created value
	 * @see			#hasMainOntSrcProperty
	 */
	public ibspan.tss.oms.ontology.OntologySource setHasMainOntSrc(com.hp.hpl.jena.rdf.model.Resource resource) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Gets the 'hasUpdateDateTime' property value
	 * @return		{@link java.lang.String}
	 * @see			#hasUpdateDateTimeProperty
	 */
	public java.lang.String getHasUpdateDateTime() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'hasUpdateDateTime' property value
	 * @param		{@link java.lang.String}
	 * @see			#hasUpdateDateTimeProperty
	 */
	public void setHasUpdateDateTime(java.lang.String hasUpdateDateTime) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Get an Iterator the 'hasNegativeOntSrc' property values.  This Iteartor
	 * may be used to remove all such values.
	 * @return		{@link java.util.Iterator} of {@link ibspan.tss.oms.ontology.OntologySource}
	 * @see			#hasNegativeOntSrcProperty
	 */
	public java.util.Iterator getHasNegativeOntSrc() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Adds a value for the 'hasNegativeOntSrc' property
	 * @param		The {@link ibspan.tss.oms.ontology.OntologySource} to add
	 * @see			#hasNegativeOntSrcProperty
	 */
	public void addHasNegativeOntSrc(ibspan.tss.oms.ontology.OntologySource hasNegativeOntSrc) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Adds an anonymous value for the 'hasNegativeOntSrc' property
	 * @return		The anoymous {@link ibspan.tss.oms.ontology.OntologySource} created
	 * @see			#hasNegativeOntSrcProperty
	 */
	public ibspan.tss.oms.ontology.OntologySource addHasNegativeOntSrc() throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Adds a value for the 'hasNegativeOntSrc' property.  This
	 * method is equivalent constructing a new instance of {@link ibspan.tss.oms.ontology.OntologySource} with the factory
	 * and calling addHasNegativeOntSrc(ibspan.tss.oms.ontology.OntologySource hasNegativeOntSrc)
	 * The resource argument have rdf:type http://www.ibspan.waw.pl/tss/OMS#OntologySource.  That is, this method
	 * should not be used as a shortcut for creating new objects in the model.
	 * @param		The {@link om.hp.hpl.jena.rdf.model.Resource} to add
	 * @see			#hasNegativeOntSrcProperty
	 */
	public ibspan.tss.oms.ontology.OntologySource addHasNegativeOntSrc(com.hp.hpl.jena.rdf.model.Resource resource) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Removes a value for the 'hasNegativeOntSrc' property.  This method should not
	 * be invoked while iterator through values.  In that case, the remove() method of the Iterator
	 * itself should be used.
	 * @param		The {@link ibspan.tss.oms.ontology.OntologySource} to remove
	 * @see			#hasNegativeOntSrcProperty
	 */
	public void removeHasNegativeOntSrc(ibspan.tss.oms.ontology.OntologySource hasNegativeOntSrc) throws com.ibm.adtech.jastor.JastorException;
		
	/**
	 * Gets the 'hasIncompleteCheckDateTime' property value
	 * @return		{@link java.lang.String}
	 * @see			#hasIncompleteCheckDateTimeProperty
	 */
	public java.lang.String getHasIncompleteCheckDateTime() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'hasIncompleteCheckDateTime' property value
	 * @param		{@link java.lang.String}
	 * @see			#hasIncompleteCheckDateTimeProperty
	 */
	public void setHasIncompleteCheckDateTime(java.lang.String hasIncompleteCheckDateTime) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'hasCF' property value
	 * @return		{@link java.lang.Float}
	 * @see			#hasCFProperty
	 */
	public java.lang.Float getHasCF() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'hasCF' property value
	 * @param		{@link java.lang.Float}
	 * @see			#hasCFProperty
	 */
	public void setHasCF(java.lang.Float hasCF) throws com.ibm.adtech.jastor.JastorException;

}