

package ibspan.tss.oms.ontology;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.rdf.listeners.StatementListener;
import com.hp.hpl.jena.vocabulary.RDF;
import com.ibm.adtech.jastor.*;
import com.ibm.adtech.jastor.util.*;


/**
 * Implementation of {@link ibspan.tss.oms.ontology.OntologySource}
 * Use the ibspan.tss.oms.ontology.OMSFactory to create instances of this class.
 * <p>(URI: http://www.ibspan.waw.pl/tss/OMS#OntologySource)</p>
 * <br>
 */
public class OntologySourceImpl extends com.ibm.adtech.jastor.ThingImpl implements ibspan.tss.oms.ontology.OntologySource {
	

	private static com.hp.hpl.jena.rdf.model.Property hasWrongTripplesProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasWrongTripples");
	private java.lang.Integer hasWrongTripples;
	private static com.hp.hpl.jena.rdf.model.Property hasCorrectTripplesProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasCorrectTripples");
	private java.lang.Integer hasCorrectTripples;
	private static com.hp.hpl.jena.rdf.model.Property hasURLProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasURL");
	private java.lang.String hasURL;
	private static com.hp.hpl.jena.rdf.model.Property hasCFProperty = ResourceFactory.createProperty("http://www.ibspan.waw.pl/tss/OMS#hasCF");
	private java.lang.Float hasCF;

	OntologySourceImpl(Resource resource, Model model) throws JastorException {
		super(resource, model);
		setupModelListener();
	}     
    	
	static OntologySourceImpl getOntologySource(Resource resource, Model model) throws JastorException {
		return new OntologySourceImpl(resource, model);
	}
	    
	static OntologySourceImpl createOntologySource(Resource resource, Model model) throws JastorException {
		OntologySourceImpl impl = new OntologySourceImpl(resource, model);
		
		if (!impl._model.contains(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(impl._resource, RDF.type, OntologySource.TYPE)))
			impl._model.add(impl._resource, RDF.type, OntologySource.TYPE);
		impl.addSuperTypes();
		impl.addHasValueValues();
		return impl;
	}
	
	void addSuperTypes() {
	}
   
	void addHasValueValues() {
	}
    
    private void setupModelListener() {
    	listeners = new java.util.ArrayList();
    	ibspan.tss.oms.ontology.OMSFactory.registerThing(this);
    }

	public java.util.List listStatements() {
		java.util.List list = new java.util.ArrayList();
		StmtIterator it = null;
		it = _model.listStatements(_resource,hasWrongTripplesProperty,(RDFNode)null);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,hasCorrectTripplesProperty,(RDFNode)null);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,hasURLProperty,(RDFNode)null);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,hasCFProperty,(RDFNode)null);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,RDF.type, ibspan.tss.oms.ontology.OntologySource.TYPE);
		while (it.hasNext()) {
			list.add(it.next());
		}
		return list;
	}
	
	public void clearCache() {
		hasWrongTripples = null;
		hasCorrectTripples = null;
		hasURL = null;
		hasCF = null;
	}

	public java.lang.Integer getHasWrongTripples() throws JastorException {
		if (hasWrongTripples != null)
			return hasWrongTripples;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, hasWrongTripplesProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": hasWrongTripples getProperty() in ibspan.tss.oms.ontology.OntologySource model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = Util.fixLiteral(literal.getValue(),"java.lang.Integer");
		hasWrongTripples = (java.lang.Integer)obj;
		return hasWrongTripples;
	}
	
	public void setHasWrongTripples(java.lang.Integer hasWrongTripples) throws JastorException {
		if (_model.contains(_resource,hasWrongTripplesProperty)) {
			_model.removeAll(_resource,hasWrongTripplesProperty,null);
		}
		this.hasWrongTripples = hasWrongTripples;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (hasWrongTripples != null) {
			_model.add(_model.createStatement(_resource,hasWrongTripplesProperty, _model.createTypedLiteral(hasWrongTripples)));
		}	
	}

	public java.lang.Integer getHasCorrectTripples() throws JastorException {
		if (hasCorrectTripples != null)
			return hasCorrectTripples;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, hasCorrectTripplesProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": hasCorrectTripples getProperty() in ibspan.tss.oms.ontology.OntologySource model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = Util.fixLiteral(literal.getValue(),"java.lang.Integer");
		hasCorrectTripples = (java.lang.Integer)obj;
		return hasCorrectTripples;
	}
	
	public void setHasCorrectTripples(java.lang.Integer hasCorrectTripples) throws JastorException {
		if (_model.contains(_resource,hasCorrectTripplesProperty)) {
			_model.removeAll(_resource,hasCorrectTripplesProperty,null);
		}
		this.hasCorrectTripples = hasCorrectTripples;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (hasCorrectTripples != null) {
			_model.add(_model.createStatement(_resource,hasCorrectTripplesProperty, _model.createTypedLiteral(hasCorrectTripples)));
		}	
	}

	public java.lang.String getHasURL() throws JastorException {
		if (hasURL != null)
			return hasURL;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, hasURLProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": hasURL getProperty() in ibspan.tss.oms.ontology.OntologySource model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = Util.fixLiteral(literal.getValue(),"java.lang.String");
		hasURL = (java.lang.String)obj;
		return hasURL;
	}
	
	public void setHasURL(java.lang.String hasURL) throws JastorException {
		if (_model.contains(_resource,hasURLProperty)) {
			_model.removeAll(_resource,hasURLProperty,null);
		}
		this.hasURL = hasURL;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (hasURL != null) {
			_model.add(_model.createStatement(_resource,hasURLProperty, _model.createTypedLiteral(hasURL)));
		}	
	}

	public java.lang.Float getHasCF() throws JastorException {
		if (hasCF != null)
			return hasCF;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, hasCFProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": hasCF getProperty() in ibspan.tss.oms.ontology.OntologySource model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = Util.fixLiteral(literal.getValue(),"java.lang.Float");
		hasCF = (java.lang.Float)obj;
		return hasCF;
	}
	
	public void setHasCF(java.lang.Float hasCF) throws JastorException {
		if (_model.contains(_resource,hasCFProperty)) {
			_model.removeAll(_resource,hasCFProperty,null);
		}
		this.hasCF = hasCF;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (hasCF != null) {
			_model.add(_model.createStatement(_resource,hasCFProperty, _model.createTypedLiteral(hasCF)));
		}	
	}
 


	private java.util.ArrayList listeners;
	
	public void registerListener(ThingListener listener) {
		if (!(listener instanceof OntologySourceListener))
			throw new IllegalArgumentException("ThingListener must be instance of OntologySourceListener"); 
		if (listeners == null)
			setupModelListener();
		if(!this.listeners.contains(listener)){
			this.listeners.add((OntologySourceListener)listener);
		}
	}
	
	public void unregisterListener(ThingListener listener) {
		if (!(listener instanceof OntologySourceListener))
			throw new IllegalArgumentException("ThingListener must be instance of OntologySourceListener"); 
		if (listeners == null)
			return;
		if (this.listeners.contains(listener)){
			listeners.remove(listener);
		}
	}



	
		public void addedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {

			if (stmt.getPredicate().equals(hasWrongTripplesProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				hasWrongTripples = (java.lang.Integer)Util.fixLiteral(literal.getValue(),"java.lang.Integer");
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						OntologySourceListener listener=(OntologySourceListener)iter.next();
						listener.hasWrongTripplesChanged(ibspan.tss.oms.ontology.OntologySourceImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasCorrectTripplesProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				hasCorrectTripples = (java.lang.Integer)Util.fixLiteral(literal.getValue(),"java.lang.Integer");
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						OntologySourceListener listener=(OntologySourceListener)iter.next();
						listener.hasCorrectTripplesChanged(ibspan.tss.oms.ontology.OntologySourceImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasURLProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				hasURL = (java.lang.String)Util.fixLiteral(literal.getValue(),"java.lang.String");
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						OntologySourceListener listener=(OntologySourceListener)iter.next();
						listener.hasURLChanged(ibspan.tss.oms.ontology.OntologySourceImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasCFProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				hasCF = (java.lang.Float)Util.fixLiteral(literal.getValue(),"java.lang.Float");
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						OntologySourceListener listener=(OntologySourceListener)iter.next();
						listener.hasCFChanged(ibspan.tss.oms.ontology.OntologySourceImpl.this);
					}
				}
				return;
			}
		}
		
		public void removedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(hasWrongTripplesProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = Util.fixLiteral(literal.getValue(),"java.lang.Integer");
				if (hasWrongTripples != null && hasWrongTripples.equals(obj))
					hasWrongTripples = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						OntologySourceListener listener=(OntologySourceListener)iter.next();
						listener.hasWrongTripplesChanged(ibspan.tss.oms.ontology.OntologySourceImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasCorrectTripplesProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = Util.fixLiteral(literal.getValue(),"java.lang.Integer");
				if (hasCorrectTripples != null && hasCorrectTripples.equals(obj))
					hasCorrectTripples = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						OntologySourceListener listener=(OntologySourceListener)iter.next();
						listener.hasCorrectTripplesChanged(ibspan.tss.oms.ontology.OntologySourceImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasURLProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = Util.fixLiteral(literal.getValue(),"java.lang.String");
				if (hasURL != null && hasURL.equals(obj))
					hasURL = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						OntologySourceListener listener=(OntologySourceListener)iter.next();
						listener.hasURLChanged(ibspan.tss.oms.ontology.OntologySourceImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(hasCFProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = Util.fixLiteral(literal.getValue(),"java.lang.Float");
				if (hasCF != null && hasCF.equals(obj))
					hasCF = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						OntologySourceListener listener=(OntologySourceListener)iter.next();
						listener.hasCFChanged(ibspan.tss.oms.ontology.OntologySourceImpl.this);
					}
				}
				return;
			}
		}

	//}
	


}